'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.default = SyntaxHighlighter;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var defaultStyle = {};
var lowlight = void 0;
if (process.env.REACT_SYNTAX_HIGHLIGHTER_LIGHT_BUILD) {
	lowlight = require('lowlight/lib/core');
} else {
	defaultStyle = require('./styles').defaultStyle;
	lowlight = require('lowlight');
}

var Text = function Text(_ref) {
	var children = _ref.children;
	return _react2.default.createElement(
		'span',
		null,
		children
	);
};

var createStyleObject = function createStyleObject(classNames, style) {
	return classNames.reduce(function (styleObject, className) {
		return _extends({}, styleObject, style[className]);
	}, {});
};

function createChildren(style) {
	var childrenCount = 0;
	return function (children) {
		childrenCount += 1;
		return children.map(function (child, i) {
			return createElement(child, style, 'code-segment-' + childrenCount + '-' + i);
		});
	};
}
function createElement(node, style, key) {
	var properties = node.properties;
	var type = node.type;
	var tagName = node.tagName;
	var value = node.value;

	if (type === "text") {
		return _react2.default.createElement(
			Text,
			{ key: key },
			value
		);
	} else if (tagName) {
		var TagName = tagName;
		var childrenCreator = createChildren(style);
		var nodeStyle = createStyleObject(properties.className, style);
		var children = childrenCreator(node.children);
		return _react2.default.createElement(
			TagName,
			{ key: key, style: nodeStyle },
			children
		);
	}
}

function SyntaxHighlighter(props) {
	var language = props.language;
	var children = props.children;
	var _props$style = props.style;
	var style = _props$style === undefined ? defaultStyle : _props$style;

	var rest = _objectWithoutProperties(props, ['language', 'children', 'style']);

	var codeTree = lowlight.highlight(language, children);
	var defaultPreStyle = style.hljs || { backgroundColor: '#fff' };
	return _react2.default.createElement(
		'pre',
		_extends({}, rest, { style: defaultPreStyle }),
		_react2.default.createElement(
			'code',
			null,
			codeTree.value.map(function (node, i) {
				return createElement(node, style, 'code-segement' + i);
			})
		)
	);
}